"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils = require("tns-core-modules/utils/utils");
var app = require("tns-core-modules/application");
var permissions = require("nativescript-permissions");
var frame_1 = require("tns-core-modules/ui/frame");
var MTSCRAEvent = com.magtek.mobile.android.mtlib.MTSCRAEvent;
var MTEMVEvent = com.magtek.mobile.android.mtlib.MTEMVEvent;
var MTDeviceConstants = com.magtek.mobile.android.mtlib.MTDeviceConstants;
var MTConnectionType = com.magtek.mobile.android.mtlib.MTConnectionType;
var MTSCRAConfig = com.magtek.mobile.android.mtlib.MTSCRAConfig;
var MTEMVDeviceConstants = com.magtek.mobile.android.mtlib.MTEMVDeviceConstants;
var MTConnectionState = com.magtek.mobile.android.mtlib.MTConnectionState.Disconnected;
var MTConnectionStateConnected = com.magtek.mobile.android.mtlib.MTConnectionState.Connected;
var m_scra, m_scraHandler, m_connectionType, readCard, m_deviceAddress, m_audioConfigType, m_deviceName, led, m_headsetReceiver, m_bluetoothFoundReceiver, m_bluetoothDiscoveryReceiver;
var devices = Array();
var activity, callback, receiver, isConnectedTimer, g_bluetoothManager, config;
var b_device = null;
var GlobalIntent;
var scanBroadcastReceiver;
var ACCESS_COARSE_LOCATION_PERMISSION_REQUEST_CODE = 222;
var ACTION_REQUEST_ENABLE_BLUETOOTH_REQUEST_CODE = 223;
var ACTION_REQUEST_BLUETOOTH_DISCOVERABLE_REQUEST_CODE = 224;
if (app.android) {
    app.android.on(app.AndroidApplication.activityCreatedEvent, function (args) {
        console.log("Event: " + args.eventName + ", Activity: " + args.activity + ", Bundle: " + args.bundle);
    });
    app.android.on(app.AndroidApplication.activityDestroyedEvent, function (args) {
        console.log("Event: " + args.eventName + ", Activity: " + args.activity);
    });
    app.android.on(app.AndroidApplication.activityStartedEvent, function (args) {
        console.log("Event: " + args.eventName + ", Activity: " + args.activity);
    });
    app.android.on(app.AndroidApplication.activityPausedEvent, function (args) {
        console.log("Event: " + args.eventName + ", Activity: " + args.activity);
    });
    app.android.on(app.AndroidApplication.activityResumedEvent, function (args) {
        console.log("Event: " + args.eventName + ", Activity: " + args.activity);
    });
    app.android.on(app.AndroidApplication.activityStoppedEvent, function (args) {
        console.log("Event: " + args.eventName + ", Activity: " + args.activity);
    });
    app.android.on(app.AndroidApplication.saveActivityStateEvent, function (args) {
        console.log("Event: " + args.eventName + ", Activity: " + args.activity + ", Bundle: " + args.bundle);
    });
    app.android.on(app.AndroidApplication.activityResultEvent, function (args) {
        console.log("Event: " + args.eventName + ", Activity: " + args.activity +
            ", requestCode: " + args.requestCode + ", resultCode: " + args.resultCode + ", Intent: " + args.intent);
    });
    app.android.on(app.AndroidApplication.activityBackPressedEvent, function (args) {
        console.log("Event: " + args.eventName + ", Activity: " + args.activity);
    });
}
var CardReader = (function (_super) {
    __extends(CardReader, _super);
    function CardReader() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CardReader.prototype.onCreate = function (savedInstanceState) {
        if (!this._callbacks) {
            frame_1.setActivityCallbacks(this);
        }
        this._callbacks.onCreate(this, savedInstanceState, _super.prototype.onCreate);
        this.startSunskyDevice();
    };
    CardReader.prototype.defaultObject = function () {
        return {
            prefix: "MAGTEK",
            type: "AUDIO",
            scanTimeout: 4000,
            callback: function (card) {
                console.log("you didn't call me back shame on you!", card);
            }
        };
    };
    CardReader.prototype.start = function (userConfig) {
        var _this = this;
        try {
            if (!this.isEmpty(userConfig)) {
                config = Object.assign(this.defaultObject(), userConfig);
            }
            if (this.hasStarted) {
                m_scra.closeDevice();
                this.hasStarted = false;
            }
            else {
                this.hasStarted = true;
                callback = config.callback;
                this.registerBroadcasters();
                g_bluetoothManager = this.bluetoothManager;
                m_scraHandler = new callbackHandler;
                m_scra = new com.magtek.mobile.android.mtlib.MTSCRA(this, m_scraHandler);
                console.log("connection with: ", config.prefix.toUpperCase(), config.type.toUpperCase());
                switch (config.prefix.toUpperCase() + "_" + config.type.toUpperCase()) {
                    case "MAGTEK_BLUETOOTH":
                        console.log("is ble supported? ", this.isBleSupported());
                        this.bluetoothManager = utils.ad.getApplicationContext().getSystemService(android.content.Context.BLUETOOTH_SERVICE);
                        this.bluetoothAdapter = this.bluetoothManager.getAdapter();
                        if (!this.bluetoothAdapter.isEnabled()) {
                            var enableBtIntent = new android.content.Intent(android.bluetooth.BluetoothAdapter.ACTION_REQUEST_ENABLE);
                            var activity_1 = app.android.foregroundActivity || app.android.startActivity;
                            app.android.on(app.AndroidApplication.activityResultEvent, function (args) {
                                _this.startBluetooth();
                            });
                            activity_1.startActivityForResult(enableBtIntent, 1);
                        }
                        else {
                            this.startBluetooth();
                        }
                        break;
                    case "MAGTEK_AUDIO":
                        m_connectionType = MTConnectionType.Audio;
                        var config_1 = this.getManualAudioConfig();
                        m_scra.setDeviceConfiguration(config_1);
                        this.startMagTekDevice();
                        break;
                    case "SUNSKY_AUDIO":
                        this.startSunskyDevice();
                        break;
                    default: {
                        console.log("No connection type found");
                        break;
                    }
                }
            }
        }
        catch (e) {
            console.log("Error on start", e);
        }
        return true;
    };
    CardReader.prototype.say = function (msg) {
        console.dir(msg);
    };
    CardReader.prototype.isBleSupported = function () {
        var PackageManager = android.content.pm.PackageManager;
        return !app.android.context.getPackageManager().hasSystemFeature(PackageManager.FEATURE_BLUETOOTH_LE);
    };
    CardReader.prototype.startBluetooth = function () {
        console.log("connection with bluetooth");
        m_connectionType = MTConnectionType.BLEEMV;
        this.startScanning();
    };
    CardReader.prototype.startScanning = function () {
        var _this = this;
        var filter = new android.content.IntentFilter();
        filter.addAction(android.bluetooth.BluetoothDevice.ACTION_FOUND);
        filter.addAction(android.bluetooth.BluetoothDevice.ACTION_ACL_CONNECTED);
        filter.addAction(android.bluetooth.BluetoothDevice.ACTION_ACL_DISCONNECTED);
        filter.addAction(android.bluetooth.BluetoothDevice.ACTION_BOND_STATE_CHANGED);
        filter.addAction(android.bluetooth.BluetoothAdapter.ACTION_STATE_CHANGED);
        filter.addAction(android.bluetooth.BluetoothAdapter.ACTION_DISCOVERY_FINISHED);
        filter.addAction(android.bluetooth.BluetoothAdapter.ACTION_DISCOVERY_STARTED);
        scanBroadcastReceiver = app.android.registerBroadcastReceiver(filter, function (context, intent) {
            _this.scanReceiver(context, intent);
        });
        this.bluetoothAdapter.startDiscovery();
        setTimeout(function () {
            _this.bluetoothAdapter.cancelDiscovery();
        }, config.scanTimeout);
    };
    CardReader.prototype.registerBroadcasters = function () {
        app.android.registerBroadcastReceiver(android.bluetooth.BluetoothDevice.ACTION_BOND_STATE_CHANGED, function (context, intent) {
            var action = intent.getAction();
            console.log("Device Action", action);
        });
    };
    CardReader.prototype.scanReceiver = function (context, intent) {
        var choice = intent.getAction();
        if (choice != null) {
            switch (choice) {
                case android.bluetooth.BluetoothAdapter.ACTION_STATE_CHANGED:
                    var state = intent.getIntExtra(android.bluetooth.BluetoothAdapter.EXTRA_STATE, android.bluetooth.BluetoothAdapter.ERROR);
                    if (state == android.bluetooth.BluetoothAdapter.STATE_OFF) {
                        console.log("bluetooth is off");
                    }
                    break;
                case android.bluetooth.BluetoothAdapter.ACTION_DISCOVERY_STARTED:
                    console.log("Discovery has started");
                    break;
                case android.bluetooth.BluetoothAdapter.ACTION_DISCOVERY_FINISHED:
                    app.android.unregisterBroadcastReceiver(scanBroadcastReceiver);
                    this.scanFinished(intent);
                    console.log("Discovery has finished");
                    break;
                case android.bluetooth.BluetoothDevice.ACTION_FOUND:
                    var device = intent.getParcelableExtra(android.bluetooth.BluetoothDevice.EXTRA_DEVICE);
                    if (device.getName() !== null) {
                        devices.push(device);
                    }
                    break;
                case android.bluetooth.BluetoothDevice.ACTION_ACL_CONNECTED:
                    console.log("Device connected");
                    break;
                case android.bluetooth.BluetoothDevice.ACTION_ACL_DISCONNECTED:
                    console.log("Device disconnected");
                    break;
                case android.bluetooth.BluetoothDevice.ACTION_BOND_STATE_CHANGED:
                    var changed = intent.getParcelableExtra(android.bluetooth.BluetoothDevice.EXTRA_DEVICE);
                    console.log("Bond State Changed: ", changed.getState());
                    break;
            }
        }
    };
    CardReader.prototype.scanFinished = function (intent) {
        var _this = this;
        var options = devices.map(function (device) {
            return device.getName();
        });
        action("Choose device", "Cancel", options)
            .then(function (result) {
            b_device = devices.find(function (device) {
                return device.getName() == result;
            });
            if (b_device !== null) {
                b_device.createBond();
                console.log(b_device.getBondState());
                console.log(b_device.getType());
                console.log(b_device.getName());
                console.log(b_device.getBluetoothClass());
                console.log(b_device.getAddress());
                console.log(b_device.hashCode());
                _this.startMagTekDevice();
            }
        });
    };
    CardReader.prototype.startSunskyDevice = function () {
        var context = android.content.Context;
        var am = app.android.context.getSystemService(context.AUDIO_SERVICE);
        if (!am.isWiredHeadsetOn()) {
            console.log('no headsets');
        }
        else {
            console.log('im listening');
            this.setVolumeToMax();
            readCard = new com.square.MagRead();
            readCard.addListener(new MagReadListener());
            readCard.start();
        }
    };
    CardReader.prototype.startMagTekDevice = function () {
        try {
            m_scra.setConnectionType(m_connectionType);
            m_scra.setConnectionRetry(true);
            switch (m_connectionType) {
                case MTConnectionType.BLEEMV:
                    m_scra.setAddress(b_device.getAddress());
                    break;
                case MTConnectionType.Audio:
                    break;
            }
            m_scra.openDevice();
        }
        catch (e) {
            console.log("Error on start", e);
        }
    };
    CardReader.prototype.requestUserPermissions = function () {
        return permissions.requestPermissions([
            android.Manifest.permission.RECORD_AUDIO,
            android.Manifest.permission.BLUETOOTH,
            android.Manifest.permission.BLUETOOTH_ADMIN,
            android.Manifest.permission.MODIFY_AUDIO_SETTINGS,
            android.Manifest.permission.ACCESS_COARSE_LOCATION,
            android.Manifest.permission.ACCESS_FINE_LOCATION,
        ]);
    };
    CardReader.prototype.hasPermissions = function () {
        return new Promise(function (resolve, reject) {
            if (permissions.hasPermission(android.Manifest.permission.RECORD_AUDIO)
                && permissions.hasPermission(android.Manifest.permission.BLUETOOTH)
                && permissions.hasPermission(android.Manifest.permission.BLUETOOTH_ADMIN)
                && permissions.hasPermission(android.Manifest.permission.MODIFY_AUDIO_SETTINGS)
                && permissions.hasPermission(android.Manifest.permission.ACCESS_COARSE_LOCATION)
                && permissions.hasPermission(android.Manifest.permission.ACCESS_FINE_LOCATION)) {
                resolve(true);
            }
            else {
                reject(false);
            }
        });
    };
    CardReader.prototype.getManualAudioConfig = function () {
        var config = "";
        m_scra.setConnectionRetry(true);
        try {
            var model = android.os.Build.MODEL.toUpperCase();
            console.log(model);
            if (model == "DROID RAZR" || model.toUpperCase() == "XT910") {
                config += "INPUT_SAMPLE_RATE_IN_HZ=48000,";
            }
            else if ((model == "DROID PRO") ||
                (model == "MB508") ||
                (model == "DROIDX") ||
                (model == "DROID2") ||
                (model == "MB525")) {
                config += "INPUT_SAMPLE_RATE_IN_HZ=32000,";
            }
            else if ((model == "GT-I9300") ||
                (model == "SPH-L710") ||
                (model == "SGH-T999") ||
                (model == "SCH-I535") ||
                (model == "SCH-R530") ||
                (model == "SAMSUNG-SGH-I747") ||
                (model == "M532") ||
                (model == "GT-N7100") ||
                (model == "GT-N7105") ||
                (model == "SAMSUNG-SGH-I317") ||
                (model == "SCH-I605") ||
                (model == "SCH-R950") ||
                (model == "SGH-T889") ||
                (model == "SPH-L900") ||
                (model == "GT-P3113")) {
                config += "INPUT_AUDIO_SOURCE=VRECOG,";
            }
            else if ((model == "XT907")) {
                config += "INPUT_WAVE_FORM=0,";
            }
            else {
                config += "INPUT_AUDIO_SOURCE=VRECOG,";
            }
        }
        catch (ex) {
            console.dir(ex);
        }
        console.dir("Configuration", config);
        return config;
    };
    CardReader.prototype.isEmpty = function (obj) {
        for (var key in obj) {
            if (obj.hasOwnProperty(key))
                return false;
        }
        return true;
    };
    CardReader.prototype.setVolumeToMax = function () {
        var context = android.content.Context;
        var am = app.android.context.getSystemService(context.AUDIO_SERVICE);
        var maxVolume = am.getStreamMaxVolume(android.media.AudioManager.STREAM_MUSIC);
        am.setStreamVolume(android.media.AudioManager.STREAM_MUSIC, maxVolume, 0);
        console.log("Volume Set to max: " + maxVolume);
    };
    CardReader.prototype.restoreVolume = function () {
        var context = android.content.Context;
        var am = app.android.context.getSystemService(context.AUDIO_SERVICE);
        var currentVolume = am.getStreamVolume(android.media.AudioManager.STREAM_MUSIC);
        am.setStreamVolume(android.media.AudioManager.STREAM_MUSIC, currentVolume, 0);
        console.log("Volume Set to 0");
    };
    CardReader = __decorate([
        JavaProxy("org.myApp.CardReader")
    ], CardReader);
    return CardReader;
}(android.app.Activity));
exports.CardReader = CardReader;
var MagReadListener = (function (_super) {
    __extends(MagReadListener, _super);
    function MagReadListener() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MagReadListener.prototype.updateBits = function (bits) {
        _super.prototype.updateBits;
    };
    MagReadListener.prototype.updateBytes = function (bytes) {
        _super.prototype.updateBytes;
        if (bytes.length > 0) {
            var card = this.getCardDetails(bytes);
            if (card.number && card.exp_month && card.exp_year) {
                callback({ 'status': 'success', 'payload': card });
            }
            else {
                callback({ 'status': 'warning', 'payload': 'Card data could not be read' });
            }
            return;
        }
        callback({ 'status': 'warning', 'payload': 'Invalid data' });
    };
    MagReadListener.prototype.getCardDetails = function (bytes) {
        var card = {
            number: null,
            exp_month: null,
            exp_year: null,
        };
        var foundCardInformation = bytes.match(/\;[0-9]+\=(.*)/g);
        if (foundCardInformation) {
            var arrayBytes = bytes.split("=", 2);
            if (arrayBytes[0]) {
                var rawCardNumber = arrayBytes[0];
                rawCardNumber = rawCardNumber.substring(1, rawCardNumber.length);
                var cardNumberHasOnlyNumberCharacters = rawCardNumber.match(/[0-9]+/g);
                card.number = cardNumberHasOnlyNumberCharacters ? rawCardNumber : null;
            }
            if (arrayBytes[1]) {
                var rawExpYear = arrayBytes[1].substring(0, 2);
                var expYearHasOnlyNumberCharacters = rawExpYear.match(/[0-9]+/g);
                card.exp_year = expYearHasOnlyNumberCharacters ? parseInt(rawExpYear) : null;
                var rawExpMonth = arrayBytes[1].substring(2, 4);
                var expMonthHasOnlyNumberCharacters = rawExpMonth.match(/[0-9]+/g);
                card.exp_month = expMonthHasOnlyNumberCharacters ? parseInt(rawExpMonth) : null;
            }
        }
        return card;
    };
    return MagReadListener;
}(com.square.MagReadListener));
exports.MagReadListener = MagReadListener;
var callbackHandler = (function (_super) {
    __extends(callbackHandler, _super);
    function callbackHandler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    callbackHandler.prototype.handleMessage = function (msg) {
        try {
            console.log("*** Callback " + msg.what);
            var state = msg.obj;
            switch (msg.what) {
                case MTSCRAEvent.OnDeviceConnectionStateChanged:
                    this.onDeviceStateChanged(state);
                    break;
                case MTSCRAEvent.OnCardDataStateChanged:
                    console.dir("OnCardDataStateChanged", state);
                    break;
                case MTSCRAEvent.OnDeviceError:
                    console.dir("OnDeviceError", state);
                    break;
                case MTSCRAEvent.OnDataReceived:
                    console.dir("OnDataReceived", state);
                    this.onCardDataReceived(state);
                    break;
                case MTSCRAEvent.OnDeviceNotPaired:
                    console.dir("OnDataReceived", state);
                    this.onCardDataReceived(state);
                    break;
                case MTSCRAEvent.OnDeviceResponse:
                    console.dir("OnDeviceResponse", state);
                    break;
                case MTSCRAEvent.OnDeviceBondingFailed:
                    console.dir("OnDeviceBondingFailed", state);
                    break;
                case MTEMVEvent.OnTransactionStatus:
                    console.dir("OnTransactionStatus", state);
                    break;
                case MTEMVEvent.OnDisplayMessageRequest:
                    console.dir("OnDisplayMessageRequest", state);
                    break;
                case MTEMVEvent.OnUserSelectionRequest:
                    console.dir("OnUserSelectionRequest", state);
                    break;
                case MTEMVEvent.OnARQCReceived:
                    console.dir("OnARQCReceived", state);
                    break;
                case MTEMVEvent.OnTransactionResult:
                    console.dir("OnTransactionResult", state);
                    break;
                case MTEMVEvent.OnEMVCommandResult:
                    console.dir("OnEMVCommandResult", state);
                    break;
                case MTEMVEvent.OnDeviceExtendedResponse:
                    console.dir("OnDeviceExtendedResponse", state);
                    break;
                default:
                    console.dir("not found?", state);
                    break;
            }
        }
        catch (ex) {
            console.log("Yey Exception", ex);
        }
        return true;
    };
    callbackHandler.prototype.onDeviceStateChanged = function (deviceState) {
        var type = deviceState.toString();
        this.setConnectionState(type);
        switch (type) {
            case "Disconnected":
                if (m_connectionType == MTConnectionType.Audio) {
                    this.restoreVolume();
                }
                break;
            case "Connected":
                if (m_connectionType == MTConnectionType.Audio) {
                    this.setVolumeToMax();
                }
                break;
            case "Error":
                console.log("Bahhh error...");
                break;
            case "Connecting":
                break;
            case "Disconnecting":
                break;
        }
    };
    callbackHandler.prototype.setConnectionState = function (state) {
        console.log("State", state);
        MTConnectionState = state;
    };
    callbackHandler.prototype.setVolumeToMax = function () {
        var context = android.content.Context;
        var am = app.android.context.getSystemService(context.AUDIO_SERVICE);
        am.getStreamMaxVolume(android.media.AudioManager.STREAM_MUSIC);
        console.log("Volume Set to max");
    };
    callbackHandler.prototype.restoreVolume = function () {
        var context = android.content.Context;
        var am = app.android.context.getSystemService(context.AUDIO_SERVICE);
        var currentVolume = am.getStreamVolume(android.media.AudioManager.STREAM_MUSIC);
        am.setStreamVolume(android.media.AudioManager.STREAM_MUSIC, currentVolume, 0);
        console.log("Volume Set to 0");
    };
    callbackHandler.prototype.onCardDataReceived = function (cardData) {
        var card = new Object({
            raw: m_scra.getResponseData(),
            cipher: m_scra.getResponseData(),
            track1: m_scra.getTrack1(),
            track2: m_scra.getTrack2(),
            ksn: m_scra.getKSN(),
            name: m_scra.getCardName(),
            inn: m_scra.getCardIIN(),
            last4: m_scra.getCardLast4(),
            pan: m_scra.getCardPAN()
        });
        if (m_scra.getResponseData()) {
            m_scra.closeDevice();
            app.android.unregisterBroadcastReceiver(m_headsetReceiver);
            callback(card);
        }
        else {
            callback(false);
        }
    };
    return callbackHandler;
}(android.os.Handler));
//# sourceMappingURL=cardreader.android.js.map